"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseCRUDManager = void 0;

var _baseManager = require("./baseManager");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var BaseCRUDManager =
/*#__PURE__*/
function (_BaseManager) {
  _inherits(BaseCRUDManager, _BaseManager);

  function BaseCRUDManager(modelName, type, container) {
    var _this;

    _classCallCheck(this, BaseCRUDManager);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BaseCRUDManager).call(this, modelName, type, container));
    _this.mongoDb = container.graphqlMongoDb;
    _this.pgsqlDb = container.graphqlPGSqlDb;
    return _this;
  }
  /** Override default for other db system */


  _createClass(BaseCRUDManager, [{
    key: "getDb",
    value: function getDb() {
      return this.mongoDb;
    } // ============== Standard CRUD Methods ======================

  }, {
    key: "get",
    value: function () {
      var _get = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(args, _ref, _ref2) {
        var auth, doAuth, session, api, data, result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                auth = _ref.auth;
                doAuth = _ref2.doAuth, session = _ref2.session;
                api = this.getDb().getAPI(this.modelName);
                _context.next = 5;
                return api.get({
                  id: args.id,
                  session: session
                });

              case 5:
                data = _context.sent;
                _context.next = 8;
                return this.authorize("get", doAuth, data, auth);

              case 8:
                _context.next = 10;
                return this.applyReadPermissions(doAuth, data, auth);

              case 10:
                result = _context.sent;
                return _context.abrupt("return", result);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x, _x2, _x3) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "query",
    value: function () {
      var _query = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(args, _ref3, _ref4) {
        var auth, doAuth, session, results;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                auth = _ref3.auth;
                doAuth = _ref4.doAuth, session = _ref4.session;
                _context2.next = 4;
                return this.authorize("query", doAuth, null, auth);

              case 4:
                _context2.next = 6;
                return this.getDb().getAPI(this.modelName).query(args.offset, args.limit, args.filter, args.sort, session);

              case 6:
                results = _context2.sent;
                _context2.next = 9;
                return this.applyQueryReadPermissions(doAuth, results.items, auth);

              case 9:
                results.items = _context2.sent;
                return _context2.abrupt("return", results);

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function query(_x4, _x5, _x6) {
        return _query.apply(this, arguments);
      }

      return query;
    }()
  }, {
    key: "create",
    value: function () {
      var _create = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(data, _ref5, _ref6) {
        var auth, doAuth, session, api, result;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                auth = _ref5.auth;
                doAuth = _ref6.doAuth, session = _ref6.session;
                _context3.next = 4;
                return this.authorize("create", doAuth, null, auth);

              case 4:
                api = this.getDb().getAPI(this.modelName);
                _context3.next = 7;
                return api.create(data, session);

              case 7:
                result = _context3.sent;
                return _context3.abrupt("return", {
                  success: true,
                  message: "".concat(this.modelName, " Created"),
                  data: result
                });

              case 9:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function create(_x7, _x8, _x9) {
        return _create.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(id, data, _ref7, _ref8) {
        var auth, doAuth, session, api, obj, result;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                auth = _ref7.auth;
                doAuth = _ref8.doAuth, session = _ref8.session;
                api = this.getDb().getAPI(this.modelName);
                _context4.next = 5;
                return api.get({
                  id: id
                });

              case 5:
                obj = _context4.sent;
                _context4.next = 8;
                return this.authorize("update", doAuth, obj, auth);

              case 8:
                _context4.next = 10;
                return api.update(id, data, session);

              case 10:
                result = _context4.sent;
                return _context4.abrupt("return", {
                  success: true,
                  message: "".concat(this.modelName, " Updated"),
                  data: result
                });

              case 12:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function update(_x10, _x11, _x12, _x13) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "delete",
    value: function () {
      var _delete2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(id, _ref9, _ref10) {
        var auth, doAuth, session, api, obj, result, props;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                auth = _ref9.auth;
                doAuth = _ref10.doAuth, session = _ref10.session;
                api = this.getDb().getAPI(this.modelName);
                _context5.next = 5;
                return api.get({
                  id: id
                });

              case 5:
                obj = _context5.sent;
                _context5.next = 8;
                return this.authorize("delete", doAuth, obj, auth);

              case 8:
                _context5.next = 10;
                return api["delete"](id, session);

              case 10:
                result = _context5.sent;
                props = Object.getOwnPropertyNames(result);

                if (!(props.length == 0)) {
                  _context5.next = 14;
                  break;
                }

                return _context5.abrupt("return", {
                  success: false,
                  message: "Delete Failed",
                  data: null
                });

              case 14:
                return _context5.abrupt("return", {
                  success: true,
                  message: "".concat(this.modelName, " Deleted"),
                  data: result
                });

              case 15:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _delete(_x14, _x15, _x16) {
        return _delete2.apply(this, arguments);
      }

      return _delete;
    }() // ===================================================
    // Helper methods
    // Many-to-one fetch from another Type

  }, {
    key: "getLinked",
    value: function () {
      var _getLinked = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(_ref11, context, options) {
        var obj, byField, result, linkId;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                obj = _ref11.obj, byField = _ref11.byField;
                result = null;

                if (!(byField in obj && obj[byField] != null)) {
                  _context6.next = 15;
                  break;
                }

                linkId = obj[byField];
                _context6.prev = 4;
                _context6.next = 7;
                return this.get({
                  id: linkId
                }, context, options);

              case 7:
                result = _context6.sent;
                _context6.next = 13;
                break;

              case 10:
                _context6.prev = 10;
                _context6.t0 = _context6["catch"](4);
                this.log.error("BaseCRUDManager.getLinked Error getting linked object: ".concat(_context6.t0.constructor.name, " msg: ").concat(_context6.t0.message));

              case 13:
                _context6.next = 15;
                break;

              case 15:
                return _context6.abrupt("return", result);

              case 16:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this, [[4, 10]]);
      }));

      function getLinked(_x17, _x18, _x19) {
        return _getLinked.apply(this, arguments);
      }

      return getLinked;
    }() // ===================================================
    // Get list of related objects based on this.id == foreign.

  }, {
    key: "getLinkedMulti",
    value: function () {
      var _getLinkedMulti = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(_ref12, context, options) {
        var obj, idField, byForeignField, filter, sort, offset, limit, result, keyValue, keyFilter;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                obj = _ref12.obj, idField = _ref12.idField, byForeignField = _ref12.byForeignField, filter = _ref12.filter, sort = _ref12.sort, offset = _ref12.offset, limit = _ref12.limit;
                idField = idField || "id";
                result = null;

                if (!(idField in obj && obj[idField] != null)) {
                  _context7.next = 16;
                  break;
                }

                keyValue = obj[idField];
                keyFilter = "".concat(byForeignField, " = '").concat(keyValue, "'");

                if (filter) {
                  keyFilter = "(".concat(keyFilter, ") AND (").concat(filter, ")");
                }

                _context7.prev = 7;
                _context7.next = 10;
                return this.query({
                  filter: keyFilter,
                  sort: sort,
                  offset: offset,
                  limit: limit
                }, context, options);

              case 10:
                result = _context7.sent;
                _context7.next = 16;
                break;

              case 13:
                _context7.prev = 13;
                _context7.t0 = _context7["catch"](7);
                this.log.error("BaseCRUDManager.getLinked Error getting linked object: ".concat(_context7.t0.constructor.name, " msg: ").concat(_context7.t0.message));

              case 16:
                return _context7.abrupt("return", result ? result.items : null);

              case 17:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[7, 13]]);
      }));

      function getLinkedMulti(_x20, _x21, _x22) {
        return _getLinkedMulti.apply(this, arguments);
      }

      return getLinkedMulti;
    }()
  }]);

  return BaseCRUDManager;
}(_baseManager.BaseManager);

exports.BaseCRUDManager = BaseCRUDManager;
//# sourceMappingURL=baseCRUDManager.js.map